#
# Parameters for all makefiles of the CO-ADC bands (cab) program suite
# Christian Buth
# 28.08.2004
#
#
# Copyright (c) 2004-2006 Christian Buth
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


#
# Directories
#

BASEDIR=$(HOME)/devel/co-adc/trunk
BINDIR=$(HOME)/local/bin
MODULES=$(BASEDIR)/modules
LANCZOS=$(BASEDIR)/lanczos


#
# Options
#

FC95=f95
FC77=f77
LK=f95
make=gmake

OPT_gen=-std95
OPT_warn=-warn argument_checking -warn declarations -warn ignore_loc -warn truncated_source -warn unused
OPT_assume=-assume byterecl
# better for testing not to give -assume buffered_io
OPT_check=-check bounds -check arg_temp_created -check format -check overflow -check underflow
OPT_inc=-I$(MODULES) -I$(LANCZOS) -module $(MODULES)

F95OPT=$(OPT_gen) $(OPT_warn) $(OPT_assume) $(OPT_check) $(OPT_inc)
F77OPT=-static $(OPT_gen) $(OPT_warn) $(OPT_assume) $(OPT_check) $(OPT_inc)


#
# Rules
#

%.o : %.F
	$(FC77) $(F77OPT) -c -O0 -o $@ $<

%.o : %.F90
	$(FC95) $(F95OPT) -c -o $@ $<
