!
! coadcdiag --- diagonalize CO-ADC matrices
! Christian Buth
! 20.06.2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!
!
! Version 1.00: 20.06.2004 (Integrated iparpackdiag and ipfulldiag)
! Version 1.10: 28.08.2004 (Renamed module from adcdiag to coadcdiag,
!       renamed ip* to ipea*, deleted routines using the ARPACK library,
!       added ipealanczosdiag, bandlanczosdiag)
!


!
! Module
!

      module coadcdiag
      use bandstructure
      implicit none


!
! Interface
!

      interface
      subroutine ipeafulldiag(am, ad)
        use coadcfile
        use bandstructure
        type(tcoadcmatrix), intent(inout) :: am
        type(tbandsatkpoint), intent(inout) :: ad
      end subroutine ipeafulldiag


      subroutine ipealanczosdiag(am, ad)
        use coadcfile
        use bandstructure
        type(tcoadcmatrix), intent(inout) :: am
        type(tbandsatkpoint), intent(inout) :: ad
      end subroutine ipealanczosdiag


      subroutine ipeamatvec(am, bw, vpre, vpost)
        use coadcfile
        use bandstructure
        integer, intent(in) :: bw
        real(dblprec), intent(in) :: vpre(:,:)
        real(dblprec), intent(out) :: vpost(:,:)
        type(tcoadcmatrix), intent(inout) :: am
      end subroutine ipeamatvec


      subroutine bandfulldiag(am, ad)
        use coadcfile
        use bandstructure
        type(tcoadcmatrix), intent(inout) :: am
        type(tbandsatkpoint), intent(inout) :: ad
      end subroutine bandfulldiag


      subroutine bandlanczosdiag(am, ad, niter)
        use coadcfile
        use bandstructure
        integer, intent(in) :: niter
        type(tcoadcmatrix), intent(inout) :: am
        type(tbandsatkpoint), intent(inout) :: ad
      end subroutine bandlanczosdiag


      subroutine bandmatvec(am, bw, vpre, vpost)
      use coadcfile
        use bandstructure
        integer, intent(in) :: bw
        complex(dblprec), intent(in) :: vpre(:,:)
        complex(dblprec), intent(out) :: vpost(:,:)
        type(tcoadcmatrix), intent(inout) :: am
      end subroutine bandmatvec
      end interface
      end module coadcdiag
