!
! fallfind --- access the matrix elements of the Fock all matrices F_ij(R)
! Christian Buth
! 10.02.2004
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!
!
! Version 1.00: 10.02.2004 (Access data read by fockall subroutine)
! Version 1.10: 10.07.2004 (Clean up of common blocks)
!


      real(dblprec) function fallfind(iorb, R, jorb) result(fallfindres)
      use fortrantl
      use Vintegrals
      implicit none
      ! implicit DOUBLE PRECISION (A-H,O-Z)

      integer, intent(in) :: iorb, R, jorb

! CB #include "param_greens"
! CB #include "common_greens"

      ! Fockmatrix hat 4 indizes
      ! 1. : =1 heit besetzt
      ! Virtuelle band indizes werden wieder bei 1 beginnend nummeriert

      if ((iorb .le. moccx) .and. (jorb .le. moccx)) then
        fallfindres = Fockmat(1,R,iorb,jorb)
      else if ((iorb .gt. moccx) .and. (jorb .gt. moccx)) then
        fallfindres = Fockmat(2,R,iorb-moccx,jorb-moccx)
      else
        fallfindres = 0
      end if
      end function fallfind
