!
! getvijkl --- load two-electron integerals into main memory
! Martin Albrecht
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


!     *******************************
      subroutine getvijkl(mijklx,nrcount)
!
!     kept in '~/greens/src'
!     *******************************

      use fortrantl
      use Vintegrals

      ! IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      implicit none

      ! CB include 'param_greens'
      ! CB include 'common_greens'
! CB korrigiert eigenen Mist      implicit integer*8 (i-n)

!Kiryu:
!c      dimension ijdummy(mijklx/10)

      integer mijklx, nnorb, ijdelete, i, j, k, l, iijj, kkll, iijjold, &
     &        kljump, ireg, irec, jrun, jv, jd, ipos, ii, jj, kk, ll,   &
     &        nrcount

      real(dblprec) fnmax

      integer ijdummy(mijklx)

      nnorb=(norb*(norb+1))/2
      fnmax=dble((nnorb*(nnorb+1))/2)

      if (mijklx.lt.nijklo) then
        write(iout,*)'SR getvijkl: mijklx<nijklo=ifla:',mijklx,nijklo
        write(iout,*)'   => more than one filling is used!!'
        write(iout,*)'      hope it fits into the memory'
      end if

      if (iVijkl-1+nijklo.gt.ndimarray) then
        write(iout,*)'SR getvijkl: not enough memory assigned '
        write(iout,*)'   to read in the Vijkl-matrix:'
        write(iout,*)'   Vijkl starts at iVijkl= ',iVijkl
        write(iout,*)'   and needs nijklo=ifla= ',nijklo
        write(iout,*)'   entrees up to iVijkl+nijklo=',nijklo+iVijkl
        write(iout,*)'   whereas "a" goes up to ndimarray=',ndimarray
        write(iout,*)'==> STOP STOP'
        stop
      end if
      if (nijklo.gt.nVXijklm) then
        write(iout,*)'SR getvijkl: not enough memory assigned '
        write(iout,*)' nijklo.gt.nVXijklm:  ',nijklo,nVXijklm
        write(iout,*)'==> STOP STOP'
        stop
      end if


      ijdelete=NBASMred*ncellm*(NBASMred*ncellm+1)/2

      write(iout,*)'sr getvijkl: basic array-allocations:'
      write(iout,*)'   nijklo   = ',nijklo
      write(iout,*)'   nVXijklm = ',nVXijklm
      write(iout,*)'   ndimarray= ',ndimarray
      write(iout,*)'   mijklx   = ',mijklx
      write(iout,*)'   iVijkl   = ',iVijkl
      write(iout,*)'   ijdelete = ',ijdelete
      write(iout,*)'      =========== '


      do i=1,nijklo
        a(iVijkl-1+i)=0.D0
      end do
!c      stop 'preliminary stop in getvijkl'
!
!        * NBASMred is the maximum number of active orbitals;
!        * we are taking ncellm to be 1 since we are writeing
!        * everything in the supercell language. The actual cell
!        * of an orbital will be figured out as usual by their numbering
!        * (orbital 1 in all cells, orbital 2 in all cells, etc.)
!
      iijj=0
      kkll=0
      iijjold=-1
      kljump=0
      ixla=0
      ijcount=0
      do i=1,nijklo
        klbuf(i)=0
      end do
      do i=1,ijdelete
        ijbuf(i)=0
      end do
      do i=1,ijdelete+1
        ijadd(i)=0
      end do
      ijadd(1)=1

      ireg=1
!       * (since we allow for only one loading anyway; all Vijkl have to be
!       *  read at one time)

      write(iout,*)'##',iVfile,iVXfile
      write(iout,*)'ioffset=',ioffset
      do irec=irecstart(ireg),irecend(ireg)
        jrun=ifillarray(irec)
        write(iout,*)'irec,jrun=',irec,jrun
        write(iout,*)'kljump=',kljump
        read(iVfile,rec=irec) (a(iVijkl-1+jv+kljump),jv=1,jrun)
!c        write(iout,*) (a(iVijkl-1+jv+kljump),jv=1,jrun)
        write(iout,*) a(iVijkl-1+jrun+kljump),iVijkl-1+jrun+kljump
        write(iout,*)'ndimarray=',ndimarray, &
     &                  DBLE(iVijkl-1+jrun+kljump)/DBLE(ndimarray)
        write(iout,*)'irec,jrun,kljump ist immer noch',irec,jrun,kljump
!c        do i=1,jrun
!c          ijdummy(i)=0
!c          klbuf(i+kljump)=0
!c        end do



        write(iout,*)'nVXijklm,jrun= ',nVXijklm,jrun, &
     &                             DBLE(jrun)/DBLE(nVXijklm)
        write(iout,*)'mijklx,jrun= ',mijklx,jrun,DBLE(jrun)/DBLE(mijklx)
!!      stop 'preliminary stop in getvijkl'
        read(iVXfile,rec=irec)(ijdummy(jd),klbuf(jd+kljump), &
     &                              jd=1,jrun)
!@!!        read(iVXfile,rec=irec)(ijdummy(jd),
!@!!     :                              jd=1,1)
!c        write(iout,*)' '
!c        write(iout,*)(ijdummy(jd),klbuf(jd+kljump),
!c     :                              jd=1,jrun)
!c!!      stop 'preliminary stop in getvijkl After STACK'
        do ipos=1,jrun
          ixla=ixla+1
          call unpack2(ijdummy(ipos),i,j)
!c          write(iout,*)'ij,i,j= ',ijdummy(ipos),i,j
          call unpack2(klbuf(ipos+kljump),k,l)
!c          write(iout,*)'kl,k,l= ',klbuf(ipos+kljump),k,l
          ii=i+ioffset
          jj=j+ioffset
          kk=k+ioffset
          ll=l+ioffset
          if (max(ii,jj,kk,ll).gt.norb) then
            write(iout,*)'getvijkl: orbital indices out of range'
            write(iout,*)'norb,ii,jj,kk,ll',norb,ii,jj,kk,ll
            stop
          end if
          iijj=ii*(ii-1)/2+jj
          kkll=kk*(kk-1)/2+ll
          if (iijj.eq.iijjold) then
            ijadd(ijcount+1)=ijadd(ijcount+1)+1
          else
            iijjold=iijj
            ijcount=ijcount+1
            ijbuf(ijcount)=iijj
            ijadd(ijcount+1)=ijadd(ijcount)+1
          end if
          klbuf(ipos+kljump)=kkll
        end do
        kljump=kljump+jrun
      end do
      ijA1=ijbuf(1)
      ijE1=ijbuf(ijcount)
      if(ijcount.gt.ijdelete)then
        write(iout,*)'getvijkl: BAD DIMENSION ERROR!!!'
        write(iout,*)'ijcount > ijdelete:'
        write(iout,*)ijcount,ijdelete
        write(iout,*)'=> STOP'
        stop
      endif

      write(iout,*)' '
      write(iout,*)'sr getvijkl: ijcount= ',ijcount
      write(iout,*)'                ixla= ',ixla
      write(iout,*)'           ijA1,ijE1= ',ijA1,ijE1
      write(iout,*)' '
!      do i=1,ijcount
!        write(iout,*)'i,ijbuf(i)',i,ijbuf(i)
!      end do
!      write(iout,*)' '

      end subroutine getvijkl
