!
! readhf --- load the Fock matrix into main memory
! Martin Albrecht
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


!     *******************************
      subroutine readhf(itask)

!     itask .eq. 0 : just get parameters from the Fock matrix file
!     itask .ne. 0:  read also the matrix
!
!     kept in '~/greens/src'
!     *******************************

      use Vintegrals

!      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
!      IMPLICIT integer (I-N)
      implicit none

      integer mocc, morb, mcelorb, mcele, mbas, ibandFstart, ibandFend, &
     &        iorb, jorb, i0, itask

      ! CB include 'param_greens'
      ! CB include 'common_greens'
      logical exHF


      inquire(file=HFname,exist=exHF)
      if (.not.exHF) then
        write(iout,*) &
     &    'sr readhf: transformed fock matrix file not found: ', &
     &                            HFname
        stop
      else
        if (icheck.lt.1) goto 100
        write(iout,*)' '
        write(iout,*)'---------------------------------------'
        write(iout,*) &
     &    'sr readhf: transformed fock matrix file found: ', &
     &                            HFname
         write(iout,*)'   going to open it:'
 100     continue
      end if

      open(unit=iHFfile,file=HFname,FORM='UNFORMATTED', &
     & STATUS='old',err=711)
      goto 712
 711  write(iout,*)'sr readhf: error opening file ',HFname
      stop
 712  continue
      if (icheck.gt.0)write(iout,*)'   opened successfully ',HFname
      read(iHFfile,err=577)mocc,morb,mcelorb,mcele,mbas, &
     &                              ibandFstart,ibandFend
      write(iout,*)'mocc,morb,mcelorb,mcele,mbas are read to be:', &
     &              mocc,morb,mcelorb,mcele,mbas
      write(iout,*)'ibandFstart,ibandFend are read to be:', &
     &              ibandFstart,ibandFend
      ncele = mcele
      nocc = mocc
      if (mocc.ne.nocc) then
        write(iout,*)'sr readhf: mocc.ne.nocc: ',mocc,nocc
        write(iout,*)'   ==> STOP STOP'
        STOP
      end if
      norb = morb
      if (morb.ne.norb) then
        write(iout,*)'sr readhf: morb.ne.norb: ',morb,norb
        write(iout,*)'   ==> STOP STOP'
        STOP
      end if
      nbas = mbas
      if (mbas.ne.nbas) then
        write(iout,*)'sr readhf: mbas.ne.nbas: ',mbas,nbas
        write(iout,*)'   correcting nbas from the input towards mbas!!'
        write(iout,*)'   ***********************'
        write(iout,*)'   *** NBAS:=MBAS !!  ****'
        write(iout,*)'   ***********************'
        write(iout,*)'   Continuing despite this input-error!!'
        nbas=mbas
      end if
      nqorb=norb*norb
      do iorb=1,morb
        i0=iHF-1+iorb*nqorb
        do jorb=1,morb
          a(i0+jorb)=0.D0
        end do
      end do
      if (itask.eq.0) then
        if (icheck.lt.2) goto 110
        write(iout,*)'only parameters ought to be read'
        write(iout,*)'   end reading fock-file'
        write(iout,*)'---------------------------------------'
        write(iout,*)' '
        goto 110
      end if
      read(iHFfile,err=577)((a(iHF-1+(iorb-1)*norb+jorb), &
     &                            jorb=ibandFstart,ibandFend), &
     &                            iorb=ibandFstart,ibandFend)

      goto 578
 577  write(iout,*)'error reading the fock file ',HFname
      stop
 578  continue
      if (icheck.lt.2) goto 110
      write(iout,*)'   end reading fock-file'
      write(iout,*)'---------------------------------------'
      write(iout,*)' '
      write(iout,*)' Fock-diagonal is:'
      do iorb=1,morb
        write(iout,*)iorb,a(iHF+iorb-1+(iorb-1)*norb)
      end do
      write(iout,*)' '
 110  continue
      close(iHFfile,status='keep')

      return
      end subroutine readhf
