!
! fallpoke --- change matrix elements of the Fock all matrices F_ij(R)
! Christian Buth
! 06.09.2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!
!
! Version 1.00: 06.09.2004 (Write data read by fockall subroutine)
!


      subroutine fallpoke(iorb, R, jorb, poke)
      use wannier
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      integer, intent(in) :: iorb, R, jorb
      real(dblprec), intent(in) :: poke

#include "param_greens"
#include "common_greens"

      ! Fockmatrix hat 4 indizes
      ! 1. : =1 heit besetzt
      ! Virtuelle band indizes werden wieder bei 1 beginnend nummeriert

      if ((iorb .le. moccx) .and. (jorb .le. moccx)) then
        Fockmat(1,R,iorb,jorb) = poke
      else if ((iorb .gt. moccx) .and. (jorb .gt. moccx)) then
        Fockmat(2,R,iorb-moccx,jorb-moccx)  = poke
      end if
      end subroutine fallpoke
