!
! geommolpro92 --- convert Wannier98 geometry output into MOLPRO1992 format
! Christian Buth
! 22.10.2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!
!
! Version 1.00: 22.10.2004 (Based on geommolpro. Read in Wannier cluster
!       geometry and write out MOLPRO1992 xyz geometry)
!


      program geommolpro92
      use fortrantl
      implicit none

      character(4) element
      character(132) line
      character(*), parameter :: symopstr = ' no. of symmetry operations.:'

      integer iatom, numAtoms, cardinal, currElem, takeElem, i
      real(dblprec) posx, posy, posz, nuccharge, nucmass, elementno(100)

      do
        read (*,'(A29)') line
        if (trim(line) == symopstr) then
          read (*,'(A15,I)') line, numAtoms
          read (*,*)
          read (*,*)
          read (*,*)
          write (*,'(A)') '!'
          write (*,'(A)') '! MOLPRO1992 geometry'
          write (*,'(A)') '!'
          write (*,*)
          write (*,'(A)') 'int'
          write (*,'(A)') 'nosym'

          elementno = 0
          currElem = 0
          do iatom=1, numAtoms
            read (*,'(I4,A4,5F15.8)') cardinal, element, posx, posy, &
     &            posz, nuccharge, nucmass

            do i=1, currElem
              if (elementno(i) == nuccharge) then
                takeElem = i
                go to 100
              end if
            end do

            currElem = currElem + 1
            takeElem = currElem
            elementno(currElem) = nuccharge

 100        write (*,'(A,I0,2A,3(A,F15.8))') ' a', takeElem, ',', trim(adjustl(element)), &
     &            ',', posx, ',', posy  , ',', posz
          end do

          stop
        end if
      end do

      stop 'Error: not a Wannier98 output'
      end program geommolpro92