!
! initwannier --- Retrive all necessary data from a Wannier Hartree-Fock calculation
! Christian Buth
! 13.02.2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!
!
! Version 1.00: 13.02.2004 (Read Fock matrix and two-electron integrals)
!


      subroutine initwannierprogram(wb, fileFockTrans, fileVBucket, fileVijkl, fileVIndex, &
     &                              fileFockAll, numorb, numocc)
      use wannier
      use Vintegrals
      implicit none

      character(len=*), intent(in) :: fileFockTrans, fileVBucket, fileVijkl, fileVIndex, fileFockAll
      integer, intent(out) :: numorb, numocc
      type(twannier), intent(inout) :: wb

! CB #include "param_greens"
! CB #include "common_greens"

      write (*,*) 'Reading Fock matrix from ', HFname
!     --------------------------------- read HF: Fij -----------
      icheck=2           ! Maximaler Testoutput
      iHF=1
!      HFname='FTRANSA'//extension//'.DAT'
      iHFfile=1
      HFname=fileFockTrans
      call readhf(1)  ! Read parameters and Fock matrix for the AO to CO transformed unit cells
!     ----------------------------------------------------------

      write (*,*) 'Reading Fockall matrix from ', 'FOCKALL0i1.DAT'
!     --------------------------------- read HF: Fij -----------

        call fockall(wb, fileFockAll)
!     ----------------------------------------------------------


      write (*,*) 'Reading two-electron integrals...'
!     --------------------------------- read integrals: Vijkl --
      nqorb=norb*norb
      iVijkl=iHF+nqorb
!      Vname='VijklD'//extension//'.DAT'
!      VXname='VINDEX'//extension//'.DAT'
!      BKTname='VBFINT'//extension//'.BKT'
      iVfile=iHFfile+15
      iVXfile=iVfile+1
      iBKTfile=iVXfile+1
      BKTname=fileVBucket
      Vname=fileVijkl
      VXname=fileVIndex
      call readvijkl
!     --------------------------------- read integrals: Vijkl --

      ncele = wb%numUnitCells           ! Number of AO to CO transformed unit cells
      numorb = norb / ncele
      numocc = nocc / ncele
      end subroutine initwannierprogram
